/// <reference types="frida-gum" />
/** Represents a `Il2CppDomain`. */
declare class Il2CppDomain {
    protected constructor();
    /** Gets the assemblies that have been loaded into the execution context of the application domain. */
    static get assemblies(): Il2Cpp.Assembly[];
    /** Gets the application domain handle. */
    static get handle(): NativePointer;
    /** Gets the encompassing object of the application domain. */
    static get object(): Il2Cpp.Object;
    /** Opens and loads the assembly with the given name. */
    static assembly(name: string): Il2Cpp.Assembly;
    /** Attached a new thread to the application domain. */
    static attach(): Il2Cpp.Thread;
    /** Opens and loads the assembly with the given name. */
    static tryAssembly(name: string): Il2Cpp.Assembly | null;
}
declare global {
    namespace Il2Cpp {
        class Domain extends Il2CppDomain {
        }
    }
}
export {};
