import { NonNullNativeStruct } from "../../utils/native-struct";
/** Represents a `Il2CppImage`. */
declare class Il2CppImage extends NonNullNativeStruct {
    /** Gets the COR library. */
    static get corlib(): Il2Cpp.Image;
    /** Gets the assembly in which the current image is defined. */
    get assembly(): Il2Cpp.Assembly;
    /** Gets the amount of classes defined in this image. */
    get classCount(): number;
    /** Gets the classes defined in this image. */
    get classes(): Il2Cpp.Class[];
    /** Gets the name of this image. */
    get name(): string;
    /** Gets the class with the specified name defined in this image. */
    class(name: string): Il2Cpp.Class;
    /** Gets the class with the specified name defined in this image. */
    tryClass(name: string): Il2Cpp.Class | null;
}
declare global {
    namespace Il2Cpp {
        class Image extends Il2CppImage {
        }
    }
}
export {};
