/// <reference types="frida-gum" />
import { NonNullNativeStruct } from "../../utils/native-struct";
/** Represents a `Il2CppType`. */
declare class Il2CppType extends NonNullNativeStruct {
    /** Gets the class of this type. */
    get class(): Il2Cpp.Class;
    /** */
    get fridaAlias(): NativeCallbackArgumentType;
    /** Determines whether this type is passed by reference. */
    get isByReference(): boolean;
    /** Determines whether this type is primitive. */
    get isPrimitive(): boolean;
    /** Gets the name of this type. */
    get name(): string;
    /** Gets the encompassing object of the current type. */
    get object(): Il2Cpp.Object;
    /** Gets the type enum of the current type. */
    get typeEnum(): Il2Cpp.Type.Enum;
    /** */
    toString(): string;
}
declare global {
    namespace Il2Cpp {
        class Type extends Il2CppType {
        }
    }
}
export {};
