/// <reference types="frida-gum" />
import { NativeStruct } from "../../utils/native-struct";
/** Value type class utility. */
declare class Il2CppValueType extends NativeStruct {
    readonly type: Il2Cpp.Type;
    constructor(handle: NativePointer, type: Il2Cpp.Type);
    /** Boxes the current value type in a object. */
    box(): Il2Cpp.Object;
    /** Gets the field with the given name. */
    field<T extends Il2Cpp.Field.Type>(name: string): Il2Cpp.Field<T>;
    /** */
    toString(): string;
}
declare global {
    namespace Il2Cpp {
        class ValueType extends Il2CppValueType {
        }
    }
}
export {};
