/// <reference types="frida-gum" />
declare class Il2CppApi {
    protected constructor();
    static get _alloc(): NativeFunction<NativePointer, [number | UInt64]>;
    static get _arrayGetElements(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _arrayGetLength(): NativeFunction<number, [NativePointerValue]>;
    static get _arrayNew(): NativeFunction<NativePointer, [NativePointerValue, number]>;
    static get _assemblyGetImage(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _classForEach(): NativeFunction<void, [NativePointerValue, NativePointerValue]>;
    static get _classFromName(): NativeFunction<NativePointer, [NativePointerValue, NativePointerValue, NativePointerValue]>;
    static get _classFromSystemType(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _classFromType(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _classGetActualInstanceSize(): NativeFunction<number, [NativePointerValue]>;
    static get _classGetArrayClass(): NativeFunction<NativePointer, [NativePointerValue, number]>;
    static get _classGetArrayElementSize(): NativeFunction<number, [NativePointerValue]>;
    static get _classGetAssemblyName(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _classGetBaseType(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _classGetDeclaringType(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _classGetElementClass(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _classGetFieldFromName(): NativeFunction<NativePointer, [NativePointerValue, NativePointerValue]>;
    static get _classGetFields(): NativeFunction<NativePointer, [NativePointerValue, NativePointerValue]>;
    static get _classGetFlags(): NativeFunction<number, [NativePointerValue]>;
    static get _classGetImage(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _classGetInstanceSize(): NativeFunction<number, [NativePointerValue]>;
    static get _classGetInterfaces(): NativeFunction<NativePointer, [NativePointerValue, NativePointerValue]>;
    static get _classGetMethodFromName(): NativeFunction<NativePointer, [NativePointerValue, NativePointerValue, number]>;
    static get _classGetMethods(): NativeFunction<NativePointer, [NativePointerValue, NativePointerValue]>;
    static get _classGetName(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _classGetNamespace(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _classGetNestedClasses(): NativeFunction<NativePointer, [NativePointerValue, NativePointerValue]>;
    static get _classGetParent(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _classGetRank(): NativeFunction<number, [NativePointerValue]>;
    static get _classGetStaticFieldData(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _classGetValueSize(): NativeFunction<number, [NativePointerValue, NativePointerValue]>;
    static get _classGetType(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _classHasReferences(): NativeFunction<number, [NativePointerValue]>;
    static get _classInit(): NativeFunction<void, [NativePointerValue]>;
    static get _classIsAbstract(): NativeFunction<number, [NativePointerValue]>;
    static get _classIsAssignableFrom(): NativeFunction<number, [NativePointerValue, NativePointerValue]>;
    static get _classIsBlittable(): NativeFunction<number, [NativePointerValue]>;
    static get _classIsEnum(): NativeFunction<number, [NativePointerValue]>;
    static get _classIsGeneric(): NativeFunction<number, [NativePointerValue]>;
    static get _classIsInflated(): NativeFunction<number, [NativePointerValue]>;
    static get _classIsInterface(): NativeFunction<number, [NativePointerValue]>;
    static get _classIsSubclassOf(): NativeFunction<number, [NativePointerValue, NativePointerValue, number]>;
    static get _classIsValueType(): NativeFunction<number, [NativePointerValue]>;
    static get _domainAssemblyOpen(): NativeFunction<NativePointer, [NativePointerValue, NativePointerValue]>;
    static get _domainGet(): NativeFunction<NativePointer, []>;
    static get _domainGetAssemblies(): NativeFunction<NativePointer, [NativePointerValue, NativePointerValue]>;
    static get _fieldGetModifier(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _fieldGetClass(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _fieldGetFlags(): NativeFunction<number, [NativePointerValue]>;
    static get _fieldGetName(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _fieldGetOffset(): NativeFunction<number, [NativePointerValue]>;
    static get _fieldGetStaticValue(): NativeFunction<void, [NativePointerValue, NativePointerValue]>;
    static get _fieldGetType(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _fieldIsLiteral(): NativeFunction<number, [NativePointerValue]>;
    static get _fieldIsStatic(): NativeFunction<number, [NativePointerValue]>;
    static get _fieldIsThreadStatic(): NativeFunction<number, [NativePointerValue]>;
    static get _fieldSetStaticValue(): NativeFunction<void, [NativePointerValue, NativePointerValue]>;
    static get _free(): NativeFunction<void, [NativePointerValue]>;
    static get _gcCollect(): NativeFunction<void, [number]>;
    static get _gcCollectALittle(): NativeFunction<void, []>;
    static get _gcDisable(): NativeFunction<void, []>;
    static get _gcEnable(): NativeFunction<void, []>;
    static get _gcGetHeapSize(): NativeFunction<Int64, []>;
    static get _gcGetMaxTimeSlice(): NativeFunction<Int64, []>;
    static get _gcGetUsedSize(): NativeFunction<Int64, []>;
    static get _gcHandleGetTarget(): NativeFunction<NativePointer, [number]>;
    static get _gcHandleFree(): NativeFunction<void, [number]>;
    static get _gcHandleNew(): NativeFunction<number, [NativePointerValue, number]>;
    static get _gcHandleNewWeakRef(): NativeFunction<number, [NativePointerValue, number]>;
    static get _gcIsDisabled(): NativeFunction<number, []>;
    static get _gcIsIncremental(): NativeFunction<number, []>;
    static get _gcSetMaxTimeSlice(): NativeFunction<void, [number | Int64]>;
    static get _gcStartIncrementalCollection(): NativeFunction<void, []>;
    static get _gcStartWorld(): NativeFunction<void, []>;
    static get _gcStopWorld(): NativeFunction<void, []>;
    static get _getCorlib(): NativeFunction<NativePointer, []>;
    static get _imageGetAssembly(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _imageGetClass(): NativeFunction<NativePointer, [NativePointerValue, number]>;
    static get _imageGetClassCount(): NativeFunction<number, [NativePointerValue]>;
    static get _imageGetName(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _init(): NativeFunction<void, []>;
    static get _livenessAllocateStruct(): NativeFunction<NativePointer, [NativePointerValue, number, NativePointerValue, NativePointerValue, NativePointerValue]>;
    static get _livenessCalculationBegin(): NativeFunction<NativePointer, [NativePointerValue, number, NativePointerValue, NativePointerValue, NativePointerValue, NativePointerValue]>;
    static get _livenessCalculationEnd(): NativeFunction<void, [NativePointerValue]>;
    static get _livenessCalculationFromStatics(): NativeFunction<void, [NativePointerValue]>;
    static get _livenessFinalize(): NativeFunction<void, [NativePointerValue]>;
    static get _livenessFreeStruct(): NativeFunction<void, [NativePointerValue]>;
    static get _memorySnapshotCapture(): NativeFunction<NativePointer, []>;
    static get _memorySnapshotFree(): NativeFunction<void, [NativePointerValue]>;
    static get _memorySnapshotGetClasses(): NativeFunction<NativePointer, [NativePointerValue, NativePointerValue]>;
    static get _memorySnapshotGetGCHandles(): NativeFunction<[number, NativePointer], [NativePointerValue]>;
    static get _memorySnapshotGetRuntimeInformation(): NativeFunction<[number, number, number, number, number, number], [NativePointerValue]>;
    static get _methodGetModifier(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _methodGetClass(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _methodGetFlags(): NativeFunction<number, [NativePointerValue, NativePointerValue]>;
    static get _methodGetFromReflection(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _methodGetName(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _methodGetObject(): NativeFunction<NativePointer, [NativePointerValue, NativePointerValue]>;
    static get _methodGetParameterCount(): NativeFunction<number, [NativePointerValue]>;
    static get _methodGetParameterName(): NativeFunction<NativePointer, [NativePointerValue, number]>;
    static get _methodGetParameters(): NativeFunction<NativePointer, [NativePointerValue, NativePointerValue]>;
    static get _methodGetParameterType(): NativeFunction<NativePointer, [NativePointerValue, number]>;
    static get _methodGetPointer(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _methodGetReturnType(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _methodIsExternal(): NativeFunction<number, [NativePointerValue]>;
    static get _methodIsGeneric(): NativeFunction<number, [NativePointerValue]>;
    static get _methodIsInflated(): NativeFunction<number, [NativePointerValue]>;
    static get _methodIsInstance(): NativeFunction<number, [NativePointerValue]>;
    static get _methodIsSynchronized(): NativeFunction<number, [NativePointerValue]>;
    static get _monitorEnter(): NativeFunction<void, [NativePointerValue]>;
    static get _monitorExit(): NativeFunction<void, [NativePointerValue]>;
    static get _monitorPulse(): NativeFunction<void, [NativePointerValue]>;
    static get _monitorPulseAll(): NativeFunction<void, [NativePointerValue]>;
    static get _monitorTryEnter(): NativeFunction<number, [NativePointerValue, number]>;
    static get _monitorTryWait(): NativeFunction<number, [NativePointerValue, number]>;
    static get _monitorWait(): NativeFunction<void, [NativePointerValue]>;
    static get _objectGetClass(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _objectGetVirtualMethod(): NativeFunction<NativePointer, [NativePointerValue, NativePointerValue]>;
    static get _objectInit(): NativeFunction<void, [NativePointerValue, NativePointerValue]>;
    static get _objectNew(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _objectGetSize(): NativeFunction<number, [NativePointerValue]>;
    static get _objectUnbox(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _resolveInternalCall(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _stringChars(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _stringLength(): NativeFunction<number, [NativePointerValue]>;
    static get _stringNew(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _stringSetLength(): NativeFunction<void, [NativePointerValue, number]>;
    static get _valueBox(): NativeFunction<NativePointer, [NativePointerValue, NativePointerValue]>;
    static get _threadAttach(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _threadCurrent(): NativeFunction<NativePointer, []>;
    static get _threadGetAllAttachedThreads(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _threadIsVm(): NativeFunction<number, [NativePointerValue]>;
    static get _threadDetach(): NativeFunction<void, [NativePointerValue]>;
    static get _typeGetName(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _typeGetObject(): NativeFunction<NativePointer, [NativePointerValue]>;
    static get _typeGetTypeEnum(): NativeFunction<number, [NativePointerValue]>;
    static get _typeIsByReference(): NativeFunction<number, [NativePointerValue]>;
    static get _typeIsPrimitive(): NativeFunction<number, [NativePointerValue]>;
}
declare global {
    namespace Il2Cpp {
        class Api extends Il2CppApi {
        }
    }
}
export {};
