import { NonNullNativeStruct } from "../../utils/native-struct";
/** Represents a `Il2CppAssembly`. */
declare class Il2CppAssembly extends NonNullNativeStruct {
    /** Gets the image of this assembly. */
    get image(): Il2Cpp.Image;
    /** Gets the name of this assembly. */
    get name(): string;
    /** Gets the encompassing object of the current assembly. */
    get object(): Il2Cpp.Object;
}
declare global {
    namespace Il2Cpp {
        class Assembly extends Il2CppAssembly {
        }
    }
}
export {};
