/** Represents a `ParameterInfo`. */
declare class Il2CppParameter {
    /** Name of this parameter. */
    readonly name: string;
    /** Position of this parameter. */
    readonly position: number;
    /** Type of this parameter. */
    readonly type: Il2Cpp.Type;
    constructor(name: string, position: number, type: Il2Cpp.Type);
    /** */
    toString(): string;
}
declare global {
    namespace Il2Cpp {
        class Parameter extends Il2CppParameter {
        }
        namespace Parameter {
            type Type = Il2Cpp.Field.Type | Il2Cpp.Reference;
        }
    }
}
export {};
