import { NativeStruct } from "../../utils/native-struct";
/** Represents a `Il2CppString`. */
declare class Il2CppString extends NativeStruct {
    /** Gets the content of this string. */
    get content(): string | null;
    /** Sets the content of this string. */
    set content(value: string | null);
    /** Gets the length of this string. */
    get length(): number;
    /** Gets the encompassing object of the current string. */
    get object(): Il2Cpp.Object;
    /** */
    toString(): string;
    /** Creates a new string with the specified content. */
    static from(content: string | null): Il2Cpp.String;
}
declare global {
    namespace Il2Cpp {
        class String extends Il2CppString {
        }
    }
}
export {};
