/// <reference types="frida-gum" />
/** Scaffold class. */
export declare class NativeStruct implements ObjectWrapper {
    readonly handle: NativePointer;
    constructor(handleOrWrapper: NativePointerValue);
    equals(other: NativeStruct): boolean;
    isNull(): boolean;
}
/** Scaffold class whom pointer cannot be null. */
export declare class NonNullNativeStruct extends NativeStruct {
    constructor(handle: NativePointer);
}
